---
title: Fundamentals of WebXR
slug: Web/API/WebXR_Device_API/Fundamentals
tags:
  - API
  - AR
  - Getting Started
  - Guide
  - Reality
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - augmented
  - basics
  - memory
---
<p>{{DefaultAPISidebar("WebXR Device API")}}{{Draft}}</p>

<p>WebXR, with the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> at its core, provides the functionality needed to bring both augmented and virtual reality (AR and VR) to the web. Together, these technologies are referred to as <strong>mixed reality</strong>, which is abbreviated <strong>MR </strong>or <strong>cross reality </strong>which is abbreviated <strong>XR </strong>and is the new trend. Mixed reality is a large and complex subject, with much to learn and many other APIs to bring together in order to create an engaging experience for users.</p>

<p><span class="seoSummary">In this guide, we provide a fundamental overview of what WebXR is and how it works, as well as providing a foundation for what you'll need to know before you even begin to learn to develop augmented reality and virtual reality experiences for the web.</span></p>

<h2 id="What_WebXR_is_and_isnt">What WebXR is and isn't</h2>

<p>WebXR is an API for web content and apps to use to interface with mixed reality hardware such as VR headsets and glasses with integrated augmented reality features. This includes both managing the process of rendering the views needed to simulate the 3D experience and the ability to sense the movement of the headset or other motion sensing apparatus to provide the needed data to let you update the imagery shown to the user based on that movement.</p>

<p>WebXR additionally provides support for accepting inputs from control devices such as handheld VR controllers or specialized mixed reality gamepads.</p>

<p><em>WebXR is not a rendering technology, and provides no features for actually managing 3D data or rendering it to the display.</em> This is an important fact to keep in mind; while WebXR manages the timing, scheduling, and the various points of view relevant when drawing the scene, it does <em>not</em> actually know how to load and manage models, render and texture them, and so forth. That part is entirely up to you. Fortunately, WebGL and the various WebGL-based frameworks and libraries are available to make it much easier to deal with all of that.</p>

<h3 id="How_is_WebXR_different_from_WebVR">How is WebXR different from WebVR?</h3>

<p>WebVR was generally considered to be an experimental API designed to help specification writers determine the best approaches to creating an API for virtual reality on the Web. As browser developers built support for WebVR and allowed developers to experiment, it became clear that in order to finish an API for virtual environments on the web, it would make more sense to start a new specification than to try to "fix" WebVR.</p>

<p>Thus, WebXR was created. The most obvious difference, at the highest level, is that WebXR supports not just virtual reality applications, but also augmented reality, which blends virtual objects with the user's true physical environment.</p>

<p>Another key difference is that WebXR has integrated support for the advanced <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">input controllers</a> that are used with most mixed reality headsets, while WebVR relied on the <a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a> to support the controllers. In WebXR, the primary select and squeeze actions are directly supported using events, while other controls are available through a special WebXR-specific implementation of the {{domxref("Gamepad")}} object.</p>

<h2 id="Basic_concepts">Basic concepts</h2>

<p>Before getting into too much detail, let's consider some basic concepts that you need to know before you learn how to develop XR code.</p>

<h3 id="Field_of_view">Field of view</h3>

<p><img alt="" src="https://mdn.mozillademos.org/files/17125/binocular-vision.svg" style="float: right; height: 367px; width: 280px;">The term <strong>field of view</strong> (<strong>FOV</strong>) is one which applies to any visual technology, from old film cameras to modern digital video cameras, including the cameras in computers and mobile devices.</p>

<h4 id="What_is_field_of_view">What is field of view?</h4>

<p>The field of view is, at its essence, the extent of the environment you are able to see at any one time. The width of the field of view is measured as the angle defining the arc from the far left edge of your field of view to the far right edge, and is specified in either degrees or radians.</p>

<p>A human eye is typically able to take in a FOV of around 135°. Assuming a person has two healthy eyes, their total field of view is about 200° to 220° wide. Why is the FOV wider with two eyes, but not double the single-eye FOV? It's because the two eyes FOVs overlap a lot. That overlap is what gives us depth perception; within the overlap area — which is around 115° across — we have depth perception. Outside that overlap area, our vision is monocular and lacks good depth perception.</p>

<p>The drawing shown here demonstrates the concept of FOV.  The blue wedge represents the field of view of the leflt eye; the red wedge is the FOV of the right eye. The overlapping area, which is sort of a shade of purple, is the area in which the viewer has binocular vision and, as a result, depth perception. If you look carefully, you'll see that each eye sees the die slightly differently, and the combined view blends the two into a 3D shape.</p>

<p>Generally, only the horizontal FOV is specifically defined and managed by applications. For more details about this, see {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Rendering", "The optics of 3D")}}.</p>

<h4 id="Field_of_view_and_mixed_reality_devices">Field of view and mixed reality devices</h4>

<p>To achieve a wide enough field of view that the user's eyes are tricked into believing that the virtual world completely surrounds them, the FOV needs to at least approach the width of the binocular vision area. Basic headsets typically start around 90° or so, while the best headsets generally have a field of view of around 150°. Because the FOV is a matter of the size of the lenses and how close they are to the user's eyes, there are limitations on how wide the FOV can get without installing lenses into the user's eyeballs.</p>

<p>A wide FOV can substantially improve the user's sense of immersion. However, increasing the FOV can also increase the weight and cost of the headset.</p>

<h3 id="Degrees_of_freedom">Degrees of freedom</h3>

<p>The term <strong>degrees of freedom</strong> is an indication of how much freedom of movement the user has within the virtual world. This is directly related to how many types of movement the WebXR hardware configuration is capable of recognizing and reproducing into the virtual scene.</p>

<div style="width: 20em; float: left; margin-right: 1em; margin-bottom: 1em;">
<figure style="background: #eee; padding: 0.5em; border: 1px solid #aaa; border-radius: 1em; max-width: 504px; padding: 1em; margin: 1em auto;">
<figcaption><strong>Diagram showing the movements possible with 3 degree of freedom hardware: yaw, roll, and pitch.</strong></figcaption>

<div style="background-color: #FFF;"><img alt="Diagram showing the movements possible with 3 degree of freedom hardware: yaw, roll, and pitch." src="https://mdn.mozillademos.org/files/17298/3-degrees-of-freedom-min.svg" style="width: 100%;"></div>
</figure>
</div>

<h4 id="Freedom_of_rotational_movement">Freedom of rotational movement</h4>

<p>The first three degrees of freedom are <strong>rotational</strong>. The rotational degrees of freedom are:</p>

<ul style="display: flow-root;">
 <li>Pitch: looking up and down</li>
 <li>Yaw: looking left and right</li>
 <li>Roll: tilting left and right</li>
</ul>

<p>In all of these cases, the viewer remains in the same location in space while pivoting on one or more of the three axes to alter the direction in which they're looking. A system with two degrees of freedom can sense when the user looks left and right or up and down, but can't report any other kind of movement.</p>

<p>A typical baseline headset offers three degrees of freedom, recognizing rotation around all three axes. This is often referred to by the shorthand <strong>3DoF</strong>.</p>

<h4 id="Freedom_of_translational_movement">Freedom of translational movement</h4>

<p>The other three degrees of freedom are translational, providing the ability to sense movement through space: forward and backward, left and right, up and down. Support for all six degrees of freedom is referred to as <strong>6DoF</strong>.</p>

<p><img alt="Diagram showing rotation around each of the three axes in a WebXR setting" src="https://mdn.mozillademos.org/files/17275/xr-translation-headset.png" style="height: 500px; width: 640px;"></p>

<p><strong>&lt;&lt;&lt;--- replace image with an SVG for future translation work and consistency ---&gt;&gt;&gt;</strong></p>

<p>Some more advanced headsets provide at least minimal support for translational movement detection, but to capture more substantial movement through the space, external sensors are usually required, such as cameras (either using visible light or infrared).</p>

<h3 id="WebXR_session_modes">WebXR session modes</h3>

<p>WebXR offers support for both augmented reality (AR) and virtual reality (VR) sessions, using the same API. Which type of session you want to create is specified when creating the session. This is done by specifying the appropriate session mode string for the kind of session you want to create.</p>

<h4 id="Virtual_reality">Virtual reality</h4>

<p>In a VR environment, the entire image is digitally created by your app or site, from foreground objects all the way to the background or skybox. Your frame drawing code will have to redraw every pixel of each view during each frame in order to avoid the potential of artifacts being left behind. Some platforms may provide previously-cleared frames to you, while others may optimize performance by not erasing the framebuffers in order to avoid having to touch each pixel twice per frame.</p>

<p>There are two VR session modes available in WebXR: <strong>inline</strong> and <strong>immersive</strong>. The former, specified by the session mode string <code>inline</code>, presents the rendered scene within the context of a document in a web browser, and doesn't require special XR hardware to view. The immersive session mode is indicated using the session mode <code>immersive-vr</code>. This session mode requires an XR device such as a headset, and replaces the entire world with the rendered scene using the displays shown to each of the user's eyes.</p>

<h4 id="Augmented_reality">Augmented reality</h4>

<p>In augmented reality (AR), the user sees the imagery you render presented on top of the physical, real-world environment around them. Because AR is always an immersive experience, in which the scene is the entire world around the user (rather than being enclosed in a box on a screen), the only AR session mode is <code>immersive-ar</code>.</p>

<div class="notecard note">
<p><a href="https://immersive-web.github.io/webxr-ar-module/">The WebXR Augmented Reality Module</a> is still in a state of early development and is not yet stable enough for regular use. We do not yet include documentation for it here on MDN, but it will come as soon as the module's specification settles down.</p>
</div>

<p>There are two basic types of AR device:</p>

<ul>
 <li>Devices which use cameras to capture the world in front of the user, render the WebXR content atop that image, then display the image on a screen. These devices include phones, which show the resulting scene on the device's screen in a 2D presentation, as well as goggles that use a pair of cameras, one for each eye, to capture the scene in stereo in order to retain the world's depth, with the WebXR scene then rendered for each eye with that eye's captured background in place.</li>
 <li>Devices which use transparent glasses to allow the user to see the world, while overlaying the rendered image atop the scene. The user is, thus, directly viewing the real world instead of a series of digital photos of it.</li>
</ul>

<p>Both types of device should be capable of also presenting VR sessions. WebXR doesn't generally care which type of device you're using, and the rendering process is almost exactly the same as for VR, except you don't erase the background or skybox before rendering each frame.</p>

<p>For more information about using WebXR to create augmented reality experiences, see <a href="/en-US/docs/Web/API/WebXR_Device_API/Augmented_reality">Augmented reality with WebXR</a>.</p>

<h2 id="Types_of_WebXR_hardware">Types of WebXR hardware</h2>

<p>The simplest XR presentation involves rendering the scene directly to the user's screen, either in the context of a web document, or in full screen mode. This is most common when the user either doesn't have a dedicated XR device, or when the user is viewing the AR or VR app on a phone or other handheld device.</p>

<p>Simpler and lower-priced XR devices typically use an integrated computer or connect to a smartphone, essentially using the mobile CPU and GPU to run apps, render images, and display them to the user. Higher-powered solutions typically offload application execution and graphics processing to an external device such as a desktop computer, and are either tethered to the computer using a cable or use a wireless network to receive the imagery to display to the user.</p>

<h3 id="Headsets">Headsets</h3>

<p><img alt="Drawing of a standard VR headset" src="https://mdn.mozillademos.org/files/17273/publicdomainq-virtual_reality_headset.svg" style="float: left; height: 270px; margin-bottom: 1em; margin-right: 1em; width: 360px;">Most immersive VR experiences take place using goggles or a headset of some kind. A VR headset is worn on the head, with a strap that goes behind the head to fasten it in place, and one or two displays whose screens are focused into the eyes using lenses. By presenting a slightly different image to each eye, the illusion of depth is created, giving the user a simulated 3D experience.</p>

<p>The vast majority of headsets use a single display whose frame is divided in half, with one half focused onto each of the user's eyes. For example, if a headset uses a 2560x1440 screen, with the left half being used for the left eye's view and the right half or the right eye's view, the framebuffer is used like this:</p>

<p><img alt="Diagram showing how a framebuffer is divided between two eyes' viewpoints" src="https://mdn.mozillademos.org/files/17011/TwoViewsOneFramebuffer.svg"></p>

<p>The simplest headsets have no integrated sensors, and focus each half of the screen into the corresponding eye. A common example of this is <a href="https://arvr.google.com/cardboard/">Google Cardboard</a>, a type of headset first created by Google which can be cheaply created using cardboard or other inexpensive materials. These devices often work by snapping your phone into the headset so that its screen and onboard graphics processor can be used to render and display the XR scene.</p>

<p>More advanced headsets have integrated displays and are strapped to the head using an elastic or strap or a strap with Velcro closure.  These headsets may include integrated speakers and microphone, and/or connectors to attach external ones. Additionally, these headsets may have various sensors for detecting when the headset moves through space. The types and number of sensors included will determine how many {{anch("degrees of freedom")}} the user has.</p>

<h3 id="Goggles_and_glasses">Goggles and glasses</h3>

<p>XR goggles are similar to headsets in that they involve the placing of graphics display surfaces in front of the eyes in order to render the views of a scene needed to simulate the depth of the simulated scene.</p>

<p>The difference is that the goggles pass through the real world, overlaying the rendered image on top of the user's physical environment. This is done without digitally reproducing the world, as would be necessary with a full headset. Instead, the display surface is transparent, and if not displaying anything is essentially identical to wearing regular eyeglasses. When objects are drawn, they are drawn onto the goggles' lenses, either partially or completely blocking the physical environment from being seen through the obscured portion of the lens.</p>

<h3 id="CAVEs">CAVEs</h3>

<p>A <strong>Cave Automated Virtual Environment</strong> (<strong>CAVE</strong>) is an immersive VR environment in which the scene is projected or otherwise displayed on the walls (as well as possibly the ceiling and/or floor), thus completely surrounding the user with the simulation and allowing them to be immersed in the scene. The user wears 3D glasses that both add the 3D effect to the projected image, but provide a means for the system to render foreground objects into the world.</p>

<p>The user's activity may be monitored using motion sensors that are worn or held by the user, or, increasingly commonly, using infrared cameras that detect the user's movements. Speakers placed around the chamber provide immersive sound as well.</p>

<p>These are not common among everyday users; they're mostly either experimental, used for demonstration purposes, or used by larger organizations. One drawback is that the CAVE can't simulate anything closer than the wall.</p>

<ul>
</ul>

<h2 id="Important_health_and_safety_reminders">Important health and safety reminders</h2>

<p>Because the entire act of creating a virtual 3D world is, in essence, a trick which takes advantage of our understanding of how eyes collect light and how the brain interprets the collected data, it is important to keep in mind that as such, software designers and developers have a responsibility to be even more careful than usual to ensure that the results are correct.</p>

<h3 id="Virtual_reality_sickness">Virtual reality sickness</h3>

<p><strong>{{interwiki("wikipedia", "Virtual reality sickness")}}</strong> is a condition in which a person experiencing virtual reality feels discomfort, disorientation, or even serious nausea during and sometimes for a short time after the experience.</p>

<p>There are a number of theories surrounding exactly what about virtual reality causes some people to feel uncomfortable or sick, most of which focusing on the idea that even subtle differences between what the brain thinks should be happening and what is being seen can cause these symptoms.</p>

<p>Defects, misalignments, or distortion can confuse the eyes and the brain, resulting in anything from aching eyes or headache to in some cases vertigo, dizziness, or potentially severe nausea. It's also important to be alert for anything you may display that may have the potential to trigger seizures, given the all-encompassing nature of a headset; the user may not be able to quickly look away from the imagery you're presenting if it's causing distress.</p>

<h3 id="Physical_risks">Physical risks</h3>

<p>Another potential issue with immersive virtual reality is the user colliding with physical obstacles if they're moving around their room while wearing a headset. Unless they're in a safe environment, it's important to provide cues to restrict their movement, such as by simulating a space that is known to be safe within their physical environment.</p>

<p>If the user's headset is tethered to a device, it's a good idea to try to ensure that the user isn't prompted or tempted to move in such a way that they pull or yank on the headset cord, which could not only cause injury, but could cause significant damage to the user's headset or device (whether it's a phone or a computer).</p>

<p>If you have any content that may be of risk to any users, you should provide a warning message. Likewise, it's worth reminding users to remain seated if possible, and to be cautious about moving around while wearing a headset if the experience is fully-immersive virtual reality. It's always better to be safe than sorry!</p>

<h2 id="The_role_of_frameworks">The role of frameworks</h2>

<p>Because 3D graphics—and mixed reality in particular—involve a lot of often intricate math, data management, and other complex tasks, it's unlikely that you'll directly use WebGL to render your scene in most cases. Instead, you'll probably do most of your work making use of one of the frameworks or libraries that are built atop WebGL to make it more convenient to use.</p>

<p>A particular benefit to using a framework rather than directly using the WebGL API is that libraries tend to implement virtual camera functionality. OpenGL (and thus WebGL by extension) does not directly offer a camera view, using a library that simulates one on your behalf can make your job much, much easier, especially when building code that allows free movement through your virtual world.</p>

<p>Since <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> is used for rendering the 3D world into the WebXR session, you should first be familiar with WebGL's general usage, and with the basics of 3D graphics in general.</p>

<h3 id="General-purpose_3D_frameworks">General-purpose 3D frameworks</h3>

<p>These frameworks are good for general-purpose programming as well as for game development when you want to do the logic yourself. They're designed for creating and animating 3D scenes regardless of context.</p>

<ul>
 <li><a href="https://aframe.io/">A-Frame</a> (specifically designed for creating WebXR-based apps)</li>
 <li><a href="https://www.babylonjs.com/">Babylon.js </a></li>
 <li><a href="https://threejs.org/">Three.js</a></li>
</ul>

<h3 id="Game_toolkits">Game toolkits</h3>

<p>The game toolkits are designed for game developers and often include gaming-specific features such as physics models, input control systems, asset management, 3D sound playback, and the like.</p>

<ul>
 <li><a href="https://playcanvas.com/">PlayCanvas</a></li>
</ul>

<h2 id="Next_steps">Next steps</h2>

<p>With these basic facts in hand, you're ready to take those next steps into the world of mixed reality. The following articles can help.</p>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Lifecycle">WebXR application life cycle </a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Startup_and_shutdown">Starting up and shutting down a WebXR session</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion: A WebXR example</a></li>
</ul>
